// This file was generated by qtwaylandscanner
// source file is example-shell.xml

#ifndef QT_WAYLAND_SERVER_EXAMPLE_SHELL
#define QT_WAYLAND_SERVER_EXAMPLE_SHELL

#include "wayland-server-core.h"
#include "wayland-example-shell-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  qt_example_shell_surface
    {
    public:
        qt_example_shell_surface(struct ::wl_client *client, uint32_t id, int version);
        qt_example_shell_surface(struct ::wl_display *display, int version);
        qt_example_shell_surface(struct ::wl_resource *resource);
        qt_example_shell_surface();

        virtual ~qt_example_shell_surface();

        class Resource
        {
        public:
            Resource() : example_shell_surface_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            qt_example_shell_surface *example_shell_surface_object;
            qt_example_shell_surface *object() { return example_shell_surface_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, uint32_t id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, uint32_t id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, uint32_t id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_minimize(uint32_t minimized);
        void send_minimize(struct ::wl_resource *resource, uint32_t minimized);

    protected:
        virtual Resource *example_shell_surface_allocate();

        virtual void example_shell_surface_bind_resource(Resource *resource);
        virtual void example_shell_surface_destroy_resource(Resource *resource);

        virtual void example_shell_surface_destroy(Resource *resource);
        virtual void example_shell_surface_set_window_title(Resource *resource, const QString &window_title);
        virtual void example_shell_surface_set_minimized(Resource *resource, uint32_t minimized);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::qt_example_shell_surface_interface m_qt_example_shell_surface_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_set_window_title(
            ::wl_client *client,
            struct wl_resource *resource,
            const char *window_title);
        static void handle_set_minimized(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t minimized);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct DisplayDestroyedListener : ::wl_listener {
            qt_example_shell_surface *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  qt_example_shell
    {
    public:
        qt_example_shell(struct ::wl_client *client, uint32_t id, int version);
        qt_example_shell(struct ::wl_display *display, int version);
        qt_example_shell(struct ::wl_resource *resource);
        qt_example_shell();

        virtual ~qt_example_shell();

        class Resource
        {
        public:
            Resource() : example_shell_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            qt_example_shell *example_shell_object;
            qt_example_shell *object() { return example_shell_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, uint32_t id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, uint32_t id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, uint32_t id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum error {
            error_role = 0, // wl_surface already has a different role
        };

    protected:
        virtual Resource *example_shell_allocate();

        virtual void example_shell_bind_resource(Resource *resource);
        virtual void example_shell_destroy_resource(Resource *resource);

        virtual void example_shell_surface_create(Resource *resource, struct ::wl_resource *surface, uint32_t id);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::qt_example_shell_interface m_qt_example_shell_interface;

        static void handle_surface_create(
            ::wl_client *client,
            struct wl_resource *resource,
            struct ::wl_resource *surface,
            uint32_t id);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct DisplayDestroyedListener : ::wl_listener {
            qt_example_shell *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
