/* Generated by wayland-scanner 1.23.0 */

#ifndef SHM_EMULATION_SERVER_BUFFER_CLIENT_PROTOCOL_H
#define SHM_EMULATION_SERVER_BUFFER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_shm_emulation_server_buffer The shm_emulation_server_buffer protocol
 * @section page_ifaces_shm_emulation_server_buffer Interfaces
 * - @subpage page_iface_qt_shm_emulation_server_buffer - shm-based server buffer for testing on desktop
 * @section page_copyright_shm_emulation_server_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2017 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_server_buffer;
struct qt_shm_emulation_server_buffer;

#ifndef QT_SHM_EMULATION_SERVER_BUFFER_INTERFACE
#define QT_SHM_EMULATION_SERVER_BUFFER_INTERFACE
/**
 * @page page_iface_qt_shm_emulation_server_buffer qt_shm_emulation_server_buffer
 * @section page_iface_qt_shm_emulation_server_buffer_desc Description
 *
 * This is software-based implementation of the qt_server_buffer extension.
 * It is intended for testing and debugging purposes only.
 * @section page_iface_qt_shm_emulation_server_buffer_api API
 * See @ref iface_qt_shm_emulation_server_buffer.
 */
/**
 * @defgroup iface_qt_shm_emulation_server_buffer The qt_shm_emulation_server_buffer interface
 *
 * This is software-based implementation of the qt_server_buffer extension.
 * It is intended for testing and debugging purposes only.
 */
extern const struct wl_interface qt_shm_emulation_server_buffer_interface;
#endif

#ifndef QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM
#define QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM
enum qt_shm_emulation_server_buffer_format {
	QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_RGBA32 = 0,
	QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_A8 = 1,
};
#endif /* QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM */

/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 * @struct qt_shm_emulation_server_buffer_listener
 */
struct qt_shm_emulation_server_buffer_listener {
	/**
	 * shm buffer information
	 *
	 * Informs the client about a newly created server buffer. The
	 * "key" argument contains a QSharedMemory key.
	 */
	void (*server_buffer_created)(void *data,
				      struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer,
				      struct qt_server_buffer *id,
				      const char *key,
				      int32_t width,
				      int32_t height,
				      int32_t bytes_per_line,
				      int32_t format);
};

/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 */
static inline int
qt_shm_emulation_server_buffer_add_listener(struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer,
					    const struct qt_shm_emulation_server_buffer_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_shm_emulation_server_buffer,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 */
#define QT_SHM_EMULATION_SERVER_BUFFER_SERVER_BUFFER_CREATED_SINCE_VERSION 1


/** @ingroup iface_qt_shm_emulation_server_buffer */
static inline void
qt_shm_emulation_server_buffer_set_user_data(struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_shm_emulation_server_buffer, user_data);
}

/** @ingroup iface_qt_shm_emulation_server_buffer */
static inline void *
qt_shm_emulation_server_buffer_get_user_data(struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_shm_emulation_server_buffer);
}

static inline uint32_t
qt_shm_emulation_server_buffer_get_version(struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_shm_emulation_server_buffer);
}

/** @ingroup iface_qt_shm_emulation_server_buffer */
static inline void
qt_shm_emulation_server_buffer_destroy(struct qt_shm_emulation_server_buffer *qt_shm_emulation_server_buffer)
{
	wl_proxy_destroy((struct wl_proxy *) qt_shm_emulation_server_buffer);
}

#ifdef  __cplusplus
}
#endif

#endif
