/* Generated by wayland-scanner 1.23.0 */

#ifndef SHM_EMULATION_SERVER_BUFFER_SERVER_PROTOCOL_H
#define SHM_EMULATION_SERVER_BUFFER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_shm_emulation_server_buffer The shm_emulation_server_buffer protocol
 * @section page_ifaces_shm_emulation_server_buffer Interfaces
 * - @subpage page_iface_qt_shm_emulation_server_buffer - shm-based server buffer for testing on desktop
 * @section page_copyright_shm_emulation_server_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2017 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_server_buffer;
struct qt_shm_emulation_server_buffer;

#ifndef QT_SHM_EMULATION_SERVER_BUFFER_INTERFACE
#define QT_SHM_EMULATION_SERVER_BUFFER_INTERFACE
/**
 * @page page_iface_qt_shm_emulation_server_buffer qt_shm_emulation_server_buffer
 * @section page_iface_qt_shm_emulation_server_buffer_desc Description
 *
 * This is software-based implementation of the qt_server_buffer extension.
 * It is intended for testing and debugging purposes only.
 * @section page_iface_qt_shm_emulation_server_buffer_api API
 * See @ref iface_qt_shm_emulation_server_buffer.
 */
/**
 * @defgroup iface_qt_shm_emulation_server_buffer The qt_shm_emulation_server_buffer interface
 *
 * This is software-based implementation of the qt_server_buffer extension.
 * It is intended for testing and debugging purposes only.
 */
extern const struct wl_interface qt_shm_emulation_server_buffer_interface;
#endif

#ifndef QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM
#define QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM
enum qt_shm_emulation_server_buffer_format {
	QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_RGBA32 = 0,
	QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_A8 = 1,
};
/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 * Validate a qt_shm_emulation_server_buffer format value.
 *
 * @return true on success, false on error.
 * @ref qt_shm_emulation_server_buffer_format
 */
static inline bool
qt_shm_emulation_server_buffer_format_is_valid(uint32_t value, uint32_t version) {
	switch (value) {
	case QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_RGBA32:
		return version >= 1;
	case QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_A8:
		return version >= 1;
	default:
		return false;
	}
}
#endif /* QT_SHM_EMULATION_SERVER_BUFFER_FORMAT_ENUM */

#define QT_SHM_EMULATION_SERVER_BUFFER_SERVER_BUFFER_CREATED 0

/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 */
#define QT_SHM_EMULATION_SERVER_BUFFER_SERVER_BUFFER_CREATED_SINCE_VERSION 1


/**
 * @ingroup iface_qt_shm_emulation_server_buffer
 * Sends an server_buffer_created event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
qt_shm_emulation_server_buffer_send_server_buffer_created(struct wl_resource *resource_, struct wl_resource *id, const char *key, int32_t width, int32_t height, int32_t bytes_per_line, int32_t format)
{
	wl_resource_post_event(resource_, QT_SHM_EMULATION_SERVER_BUFFER_SERVER_BUFFER_CREATED, id, key, width, height, bytes_per_line, format);
}

#ifdef  __cplusplus
}
#endif

#endif
